require 'thread'
require 'arb/block'

if __FILE__ == $0
  class Front
    def initialize
      @count = 1
    end

    def log(s)
      @count += 1
      puts s
      s * @count
    end

    def each
      [1, 2, 3].each do |x|
	yield x
      end
    end

    def ary(*arg)
      arg
      # Thread.current[:ARb]['message'].sender.kill
    end

    def puts(s)
      super(s)
    end
  end

  ARb::ARbObject.new('here', Front.new)

  block = ARb::ARbBlock.new('here.log("hi")', 100)
  block.run
  p block.value

  begin
    block = ARb::ARbBlock.new('sleep 10; here.log("hi")', 1)
    block.run
    p block.value
  rescue ARb::ARbError
    p $!
  end

  begin
    block = ARb::ARbBlock.new('10.times do here.log("hi") end', 10, 5)
    block.run
    p block.value
  rescue ARb::ARbError
    p $!
  end

  untrusted_code = <<EOS
sum = 0
(1..10).each do |n|
  here.puts n
  sum += n
end
here.puts sum
sum
EOS

  begin
    block = ARb::ARbBlock.new(untrusted_code, 2, 10)
    block.run
    p block.value
  rescue ARb::ARbError
    p $!
  end
end
